﻿# Créé par Boulanger, le 19/01/2023 en Python 3.4
import matplotlib.pyplot as plt  # Importation des bibliothèques nécessaires
from math import *

# Déclaration des variables du problème
m = 80 # masse du sauteur en kg
g = 9.8 # intensité du champ de pesanteur terrestre en m/s²
zA = 27 # altitude initiale du sauteur en m
vA = 0 # vitesse initiale du sauteur en m/s

# Initialisation des listes vides
t = [] # durée de la chute
vP = [] # Vitesse du plongeur
EcP = [] # énergie cinétique du sauteur
EppP = [] # énergie potentielle de pesanteur du sauteur
EmP = [] # énergie mécanique du sauteur

# Remplissage des listes
for h in range (0,zA+1,1) : # la hauteur de chute h varie par pas de 1 m de 0 à 27 m
     t.append(sqrt(2*h/g)) # durée de la chute
     vP.append(sqrt(vA*vA+2*g*h)) # vitesse du plongeur en m/s
     EcP.append(0.5*m*(vA*vA+2*g*(h))) # énergie cinétique du plongeur
     EppP.append(m*g*(zA-h)) # énergie potentielle de pesanteur du plongeur
     EmP.append(0.5*m*(vA*vA+2*g*(h))+m*g*(zA-h)) # énergie mécanique du plongeur


# Ecriture de la vitesse d'impact arrondie à l'unité en m/s
print("Vitesse d'impact en m/s :")
print(round((vP[zA])))

# Tracé des courbes
plt.plot(t,EppP,"go--",label="EppP")
plt.plot(t,EcP,"ro--",label="EcP")
plt.plot(t,EmP,"yo--",label="EmP")
plt.title("Evolution temporelle des énergies du plongeur")
plt.xlabel('Durée de la chute en s')
plt.ylabel('Energies en J')
plt.grid()
plt.legend()
plt.show()